﻿#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7

#Region POP3.au3 - INDEX
;===============================================================================
; Name ..........: POP3.au3
; Author: .......: Apzo - Luc HENNINOT <lhenninot@nordnet.fr>
; Author: .......: Tipulatoid - _pop3.au3 , MrCreatoR - _POP3_EML_Parser()
; Modified ......: Thorsten Willert (thorsten [dot] willert [at] gmx [dot] de)
; Modified ......: Oscar
; Modified ......: mLipok
; AutoIt ........: v3.3.10.2++
; URL ...........: http://www.autoitscript.com/forum/index.php?showtopic=167339
; Date ..........: 2016/05/04
; Version .......: 2.0.1
;===============================================================================
#CS
	Original UDF:
	http://www.autoitscript.com/forum/index.php?showtopic=22838
	Basic functions for AU3 Scripts, based on the 1939 RFC ( http://www.ietf.org/rfc/rfc1939.txt ).
	Author : Apzo - Luc HENNINOT <lhenninot@nordnet.fr>
	Modified : Thorsten Willert (thorsten [dot] willert [at] gmx [dot] de)

	2015/02/09 ver. 1.0.0
	Modified : mLipok    http://www.autoitscript.com/forum/user/10673-mlipok/
	(Function names Changed, Variables names Changed, added new functions, added Quoted-printable.au3, Script CleanUp, $g__bPOP3_TRACE and $g__vPOP3_ISCONNECTED Removed)
	Requires AU3 v3.3.10.2+ and UDF: Quoted-printable.au3


	2016/05/04 ver. 2.0.1
	.	Renamed: 	UDF:	_POP3_Ex.au3 >> POP3.au3 - mLipok
	.	Renamed: 	Var:	$g__iPOP3_SOCKET >> $__g_iPOP3_SOCKET - mLipok
	.	Renamed: 	Var:	$POP3_OK >> $POP3_REGEXP_OK - mLipok
	.	New: 		Var:	$POP3_REGEXP_ERR - mLipok
	.	New: 		Var:	$POP3_REGEXP_PASS - mLipok
	.	New: 		Var:	$POP3_CALLBACK_COMMAND - mLipok
	.	New: 		Var:	$POP3_CALLBACK_STATUS - mLipok
	.	Renamed: 	Enums: 	$POP3_ERROR_* >> $POP3_ERR_* - mLipok
	.	Renamed: 	Enum: 	$POP3_ERR_OK >> $POP3_ERR_SUCCESS - mLipok
	.	Renamed: 	Enum: 	$POP3_ERR >> $POP3_ERR_GENERAL - mLipok
	.	Renamed: 	Enum: 	$POP3_ERR_SERVER_RESPONSE_TIMEOUT >> $POP3_ERR_TIMEOUT - mLipok
	.	Renamed: 	Enum: 	$POP3_ERR_TCPRECV_TIMEOUT >> $POP3_ERR_TIMEOUT - mLipok
	.	Renamed: 	Enum: 	$POP3_ERR_TCPCONNECT_FAILED >> $POP3_ERR_TCPCONNECT - mLipok
	.	New:     	Enum: 	$POP3_ERR_TCPSTARTUP - mLipok
	.	New: 		Enum: 	$POP3_ERR_SSL - mLipok
	.	New: 		Enum: 	$POP3_EXT_CONNECTED - mLipok
	.	New:     	Enum: 	$POP3_ERR_TCPRECV - mLipok
	.	New:		Func: 	_POP3_UDFVersion - mLipok
	.	Removed: 	Enum: 	$POP3_ERR_ALREADY_CONNECTED --> Check for $POP3_EXT_CONNECTED - mLipok
	.	Removed: 	Enum: 	$POP3_ERR_NO_TCP_RESPONSE - is no longer used - mLipok
	.	Removed: 	Enum: 	$POP3_ERR_NO_OK_RESPONSE - is no longer used - mLipok
	.	Renamed: 	Func:	__POP3_Cmd >> __POP3_SendCommand - mLipok
	.	Renamed: 	Func:	_POP3_ConsoleDebug >> _POP3_Callback - mLipok
	.	Renamed: 	Func:	_POP3_ConsoleError >> _POP3_CallbackError - mLipok
	.	Removed: 	Func:	_POP3_CallbackSatus --> _POP3_Callback(FirstClassFunction) - mLipok
	.	Renamed: 	Func:	_POP3_ServerIsConnected >> _POP3_IsConnected - mLipok
	.	Renamed: 	Func:	_POP3_ServerIsAuth >> _POP3_IsAuthorized - mLipok
	.	Removed:	Func: 	_POP3_CallbackFunction - mLipok
	.	Refactored: Func:	_POP3_IsConnected - mLipok
	.	Refactored: Func:	_POP3_IsAuthorized - mLipok
	.	Refactored: Func: 	_POP3_RFC_... Functions: Finally correctly reporting: $POP3_ERR_**_REFUSED - mLipok
	.	Refactored: Func: 	All faunction - mLipok
	.				If _POP3_IsAuthorized() Then  >>> checking @error
	.	Refactored: Func:	@error handling almost all functions - mLipok
	.				If @error Then Return SetError(@error, @extended, .......
	.	Refactored:	Var:	Magic Number replaced with Const/Enums - mLipok
	.
	.
	.
	.
	@LAST
	.
	.
	@TODO
	.	_POP3_RFC_APOP


#CE

#EndRegion POP3.au3 - INDEX

#Region POP3.au3 - Include
#include-once
#include <StringConstants.au3>
#include <FileConstants.au3>
#include <array.au3>
#include "Quoted-printable.au3"
#EndRegion POP3.au3 - Include

#Region POP3.au3 - Global Constants and Enums


; -- _POP3 error codes, sent by SetError. Use @error to display it. --
Global Enum _
		$POP3_ERR_SUCCESS = 0, _ ;				-
		$POP3_ERR_GENERAL, _ ;					-
		$POP3_ERR_PARAMETER, _ ;				-
		$POP3_ERR_SSL, _ ;				-
		$POP3_ERR_TCPSTARTUP, _ ;				-
		$POP3_ERR_TCPCONNECT, _ ;				-
		$POP3_ERR_TCPRECV, _ ;					-
		$POP3_ERR_TIMEOUT, _ ;					-
		$POP3_ERR_NOT_CONNECTED, _ ;			-
		$POP3_ERR_NO_AUTH, _ ;					-
		$POP3_ERR_ERR_RESPONSE, _ ;				-
		$POP3_ERR_CMD_REFUSED, _ ;				-
		$POP3_ERR_USER_REFUSED, _ ;				-
		$POP3_ERR_PASS_REFUSED, _ ;			-
		$POP3_ERR_LIST_REFUSED, _ ;				-
		$POP3_ERR_RSET_REFUSED, _ ;				-
		$POP3_ERR_RETR_REFUSED, _ ;				-
		$POP3_ERR_QUIT_REFUSED, _ ;				-
		$POP3_ERR_DELE_REFUSED, _ ;				-
		$POP3_ERR_TOP_REFUSED, _ ;				-
		$POP3_ERR_NOOP_REFUSED, _ ;				-
		$POP3_ERR_STAT_REFUSED, _ ;				-
		$POP3_ERR_UIDL_REFUSED, _ ;				-
		$POP3_ERR_STAT_BADRESPONSE, _ ;			-
		$POP3_ERR_ENUMCOUNTER ;-------------	just for testing

Global Enum _
		$POP3_EXT_DEFAULT, _ ;					default Extended Value
		$POP3_EXT_PARAM1, _ ;					Error Occurs in 1-Parameter
		$POP3_EXT_PARAM2, _ ;					Error Occurs in 2-Parameter
		$POP3_EXT_PARAM3, _ ;					Error Occurs in 3-Parameter
		$POP3_EXT_PARAM4, _ ;					Error Occurs in 4-Parameter
		$POP3_EXT_PARAM5, _ ;					Error Occurs in 5-Parameter
		$POP3_EXT_PARAM6, _ ;					Error Occurs in 6-Parameter
		$POP3_EXT_CONNECTED, _ ;				Was connected before
		$POP3_EXT_ENUMCOUNTER ;-------------	just for testing

Global Enum _
		$POP3_RET_FAILURE = -1, _ ;				Failure result
		$POP3_RET_SUCCESS = 1, _ ;				Successful result
		$POP3_RET_ENUMCOUNTER ;-------------	just for testing

Global Const $POP3_CALLBACK_COMMAND = '> C: '
Global Const $POP3_CALLBACK_STATUS = '< S: '
Global Const $POP3_REGEXP_OK = '^\+OK\s?' ; Regexp syntax
Global Const $POP3_REGEXP_ERR = '^\-ERR\s?' ; Regexp syntax
Global Const $POP3_REGEXP_PASS = '^' & $POP3_CALLBACK_COMMAND & 'PASS\s\V+' ; Regexp syntax
#EndRegion POP3.au3 - Global Constants and Enums

#Region POP3.au3 - Global variables
Global $__g_iPOP3_SOCKET
#EndRegion POP3.au3 - Global variables

#Region POP3.au3 - rfc1939 Functions ; http://www.ietf.org/rfc/rfc1939.txt

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_DELE
; Description ...: Delete msg n-msg_number.
; Syntax ........: _POP3_RFC_DELE($iMessageNumber)
; Parameter(s): .: $iMessageNumber
; Return Value ..: Success - server response
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_DELE($iMessageNumber)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	Local $sResult = __POP3_SendCommand("DELE " & $iMessageNumber, $POP3_ERR_DELE_REFUSED)
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

;~ 	Local $sResult = __POP3_WaitTcpResponse()
;~ 	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>_POP3_RFC_DELE

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_LIST
; Description ...: Returns an array with the msg number and its size (octets)
; Syntax ........: _POP3_RFC_LIST([$iMessageNumber = -1])
; Parameter(s): .: $iMessageNumber - Optional: (Default = -1) :
; | -1 = all
; Return Value ..: Success - array[n][2]
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert, Oscar
; Link ..........:
; Related .......: _POP3_RFC_UIDL
; Example .......: No
; ==============================================================================
Func _POP3_RFC_LIST($iMessageNumber = -1)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	Local $aResult[1][2], $aTMP2
	Local $sAddMsg = ""

	If $iMessageNumber <> -1 Then $sAddMsg = $iMessageNumber

	Local $sResult = __POP3_SendCommand("LIST " & $sAddMsg, $POP3_ERR_LIST_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	While $iMessageNumber = -1 And Not StringRegExp($sResult, "\r\n\.\r\n")
		$sResult &= __POP3_WaitTcpResponse()
		If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)
	WEnd

	$sResult = StringRegExpReplace($sResult, '.+?message.+\(.+\)\r\n', @LF) ; Yahoo-Support, by Oscar

	; Stripping useless infos for complete listing
	If $iMessageNumber = -1 Then
		$sResult = StringMid($sResult, 2, StringLen($sResult) - 6)
	Else
		$sResult = StringMid($sResult, 1, StringLen($sResult) - 2)
	EndIf

	Local $aTMP = StringSplit(StringStripCR($sResult), @LF)

	Local $iE = UBound($aTMP)
	ReDim $aResult[$iE][2]
	$aResult[0][0] = $iE - 1
	For $i = 1 To $iE - 1
		$aTMP2 = StringSplit($aTMP[$i], " ", $STR_NOCOUNT)
		$aResult[$i][0] = $aTMP2[0]
		$aResult[$i][1] = $aTMP2[1]
	Next

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aResult)
EndFunc   ;==>_POP3_RFC_LIST

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_NOOP
; Description ...: Actually, does nothing.
; Syntax ........: _POP3_RFC_NOOP()
; Parameter(s): .: none
; Return Value ..: Success - $POP3_RET_SUCCESS
; Failure - $POP3_RET_FAILURE
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Remark(s) .....: The most interesting command from RFC 1939 ;)
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_NOOP()
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	__POP3_SendCommand("NOOP", $POP3_ERR_NOOP_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $POP3_RET_SUCCESS)
EndFunc   ;==>_POP3_RFC_NOOP

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_QUIT
; Description ...: Validates your actions (dele for example) and stops the connection as it should.
; Syntax ........: _POP3_RFC_QUIT()
; Parameter(s): .: none
; Return Value ..: Success - $sResult
; Failure - $POP3_RET_FAILURE
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_QUIT()
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	Local $sResult = __POP3_SendCommand("QUIT", $POP3_ERR_QUIT_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>_POP3_RFC_QUIT

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_RETR
; Description ...: Downloads the according message
; Syntax ........: _POP3_RFC_RETR([$iMessageNumber = -1])
; Parameter(s): .: $iMessageNumber - Optional: (Default = -1) :
; | -1 = newest
; Return Value ..: Success - string
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_RETR($iMessageNumber = -1)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	If $iMessageNumber = -1 Then
		Local $aStat = _POP3_RFC_STAT()
		If Not @error Then $iMessageNumber = $aStat[0]
	EndIf

	Local $sResult = __POP3_SendCommand("RETR " & $iMessageNumber, $POP3_ERR_RETR_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	; Downloading until final dot and cariage return.
	While Not StringRegExp($sResult, "\r\n\.\r\n")
		$sResult &= __POP3_WaitTcpResponse(False)
		If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)
	WEnd

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>_POP3_RFC_RETR

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_RSET
; Description ...: Withdraw changes, such as dele orders
; Syntax ........: _POP3_RFC_RSET()
; Parameter(s): .: none
; Return Value ..: Success - 1
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_RSET()
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	Local $sResult = __POP3_SendCommand("RSET", $POP3_ERR_RSET_REFUSED)
	If @error Then Return SetError(@error, @extended, $sResult)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>_POP3_RFC_RSET

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_STAT
; Description ...: Gets the number of messages in the POP3 account (array[1]) and the size(array[2]) in octets
; Syntax ........: _POP3_RFC_STAT()
; Parameter(s): .: none
; Return Value ..: Success - array
; Failure - array[-1,-1]
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......: _POP3_MsgCnt
; Example .......: No
; ==============================================================================
Func _POP3_RFC_STAT()
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	Local $aResult[2] = [-1, -1]

	Local $sResult = __POP3_SendCommand("STAT", $POP3_ERR_STAT_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	$sResult = StringStripWS($sResult, $STR_STRIPLEADING + $STR_STRIPTRAILING)
	$aResult = StringSplit($sResult, " ", $STR_NOCOUNT)
	If UBound($aResult) Then Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aResult)

	_POP3_CallbackError("_POP3_RFC_STAT: $POP3_ERR_STAT_BADRESPONSE")
	Return SetError($POP3_ERR_STAT_BADRESPONSE, $POP3_EXT_DEFAULT, $aResult)
EndFunc   ;==>_POP3_RFC_STAT

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_TOP
; Description ...: Retreives the mail headers, and the X first lines of the message
; Syntax ........: _POP3_RFC_TOP([$iMessageNumber = -1[, $iLines = 0]])
; Parameter(s): .: $iMessageNumber - Optional: (Default = -1) :
; | -1 : newest
; $iLines - Optional: (Default = 0) :
; Return Value ..: Success - string
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_RFC_TOP($iMessageNumber = -1, $iLines = 0)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	If $iMessageNumber = -1 Then
		Local $aStat = _POP3_RFC_STAT()
		If Not @error Then $iMessageNumber = $aStat[0]
	EndIf

	Local $sResult = __POP3_SendCommand("TOP " & $iMessageNumber & " " & $iLines, $POP3_ERR_TOP_REFUSED) ; Send Top
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	; Downloading until final dot and cariage return.
	While Not StringRegExp($sResult, "\r\n\.\r\n")
		$sResult &= __POP3_WaitTcpResponse()
		If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)
	WEnd

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>_POP3_RFC_TOP

; #FUNCTION# ===================================================================
; Name ..........: _POP3_RFC_UIDL
; Description ...: Same as _POP3_RFC_LIST(), but with UIDL identifiers instead of message size.
; Syntax ........: _POP3_RFC_UIDL([$iMessageNumber = -1])
; Parameter(s): .: $iMessageNumber - Optional: (Default = -1) :
; Return Value ..: Success - array[n][2]
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Link ..........:
; Related .......: _POP3_RFC_LIST
; Example .......: No
; ==============================================================================
Func _POP3_RFC_UIDL($iMessageNumber = Default)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	If $iMessageNumber = Default Then $iMessageNumber = ""

	Local $sResult = __POP3_SendCommand("UIDL " & $iMessageNumber, $POP3_ERR_UIDL_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	While $iMessageNumber = "" And Not StringRegExp($sResult, "\r\n\.\r\n")
		$sResult &= __POP3_WaitTcpResponse()
		If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)
	WEnd

	; Stripping useless infos for complete listing
	If $iMessageNumber = -1 Then
		$sResult = StringMid($sResult, 2, StringLen($sResult) - 6)
	Else
		$sResult = StringMid($sResult, 1, StringLen($sResult) - 2)
	EndIf

	Local $aOuter = StringRegExp($sResult, '(\d+)\s(UID\d+-\d+)', $STR_REGEXPARRAYGLOBALFULLMATCH)

	Local Enum $INNER_LINE, $INNER_MSGID, $INNER_UID, $INNER_MAX
	#forceref $INNER_LINE
	Local $aResult[UBound($aOuter) + 1][$INNER_MAX - 1]
	$aResult[0][0] = UBound($aOuter)

	For $iOuter_idx = 0 To UBound($aOuter) - 1
		$aResult[$iOuter_idx + 1][$INNER_MSGID - 1] = ($aOuter[$iOuter_idx])[$INNER_MSGID]
		$aResult[$iOuter_idx + 1][$INNER_UID - 1] = ($aOuter[$iOuter_idx])[$INNER_UID]
	Next

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aResult)
EndFunc   ;==>_POP3_RFC_UIDL

#EndRegion POP3.au3 - rfc1939 Functions ; http://www.ietf.org/rfc/rfc1939.txt

#Region POP3.au3 - UDF Function
; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_Info
; Description ...: Returns an array with the specified informations about all mails
; Syntax ........: _POP3_Info([$v_Info = Default[, $iNumberOfMessages = Default]])
; Parameters ....: $v_Info              - [optional] A variant value. Default is Default. String or array
;                  $iNumberOfMessages   - [optional] An integer value. Default is Default.
; Return values .:
;                  Success - array (Default: array[date,from,to,subject])
;                  Failure - 0
; Author ........: Thorsten Willert
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: Yes
; ===============================================================================================================================
Func _POP3_Info($v_Info = Default, $iNumberOfMessages = Default)
	_POP3_IsConnected()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized()
	If @error Then SetError(@error, @extended, $POP3_RET_FAILURE)

	If $v_Info = Default Then
		Local $aFiledNames[4] = ["Date", "From", "To", "Subject"]
	ElseIf IsArray($v_Info) Then
		$aFiledNames = $v_Info
	Else
		$aFiledNames = StringSplit($v_Info, ',', $STR_NOCOUNT)
	EndIf

	Local $iMessageNumber_Count = _POP3_MsgCnt()
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	If $iNumberOfMessages <> Default Then
		; TODO
	EndIf

	Local $sTMP_EML, $aTMP_EML_Fields
	Local $iFields_Count = UBound($aFiledNames)

	If $iMessageNumber_Count > 0 Then
		Local $aResult[$iMessageNumber_Count + 1][$iFields_Count]
		$aResult[0][0] = $iMessageNumber_Count
		For $iMessageNumber_idx = 1 To $iMessageNumber_Count
			$sTMP_EML = _POP3_RFC_TOP($iMessageNumber_idx)
			If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

			For $iField = 0 To $iFields_Count - 1
				$aTMP_EML_Fields = StringRegExp($sTMP_EML, '(?i)\n' & $aFiledNames[$iField] & ':\s*(.*?)\R', $STR_REGEXPARRAYGLOBALMATCH)
				If Not @error Then $aResult[$iMessageNumber_idx][$iField] = $aTMP_EML_Fields[0]
			Next
		Next
		Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aResult)
	EndIf

	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
EndFunc   ;==>_POP3_Info

; #FUNCTION# ===================================================================
; Name ..........: _POP3_ServerConnect
; Description ...: Connect to the POP3 server.
; Syntax ........: _POP3_ServerConnect($sServerName[, $iPort = 110])
; Parameters ....: $sServerName         - a string value. POP3 server
;                  $iPort               - [optional] an integer value. Default is 110.
; Return Value ..: Success - 1
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert, mLipok
; Link ..........:
; Related .......: _POP3_ServerLogIn()
; Example .......: No
; ==============================================================================
Func _POP3_ServerConnect($sServerName, $iPort = 110)
	If _POP3_IsConnected() Then Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_CONNECTED, $POP3_RET_SUCCESS)

	If $iPort = 995 Then
		_POP3_CallbackError("_POP3_ServerConnect: Error: SSL not supported ..." & @CRLF)
		Return SetError($POP3_ERR_SSL, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
	EndIf

	TCPStartup()
	If @error Then Return SetError($POP3_ERR_TCPSTARTUP, @error, $POP3_RET_FAILURE)

	; Basic name to IP conversion
	_POP3_Callback("_POP3_ServerConnect: connecting to: " & $sServerName & "  - using port: " & $iPort & @CRLF)
	If StringRegExp($sServerName, "[a-zA-Z]") Then
		Local $sServerIP = TCPNameToIP($sServerName)
		_POP3_Callback($sServerName & " >> " & $sServerIP & @CRLF)
		$sServerName = $sServerIP
	EndIf

	$__g_iPOP3_SOCKET = TCPConnect($sServerName, $iPort)
	If @error Then
		_POP3_CallbackError("_POP3_ServerConnect: Error: $POP3_ERR_TCPCONNECT")
		Return SetError($POP3_ERR_TCPCONNECT, @error, $POP3_RET_FAILURE)
	EndIf

	__POP3_WaitForOK() ; We need a first OK from POP3 Server
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)


	_POP3_IsConnected(True)
	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $POP3_RET_SUCCESS)
EndFunc   ;==>_POP3_ServerConnect

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_ServerLogIn
; Description ...: Login to POP3 Conneted server
; Syntax ........: _POP3_ServerLogIn($sUserName, $sPassword)
; Parameters ....: $sUserName           - a string value.
;                  $sPassword           - a string value.
; Return values .: None
; Author ........: Lipok
; Modified ......:
; Remarks .......:
; Related .......: _POP3_ServerConnect()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_ServerLogIn($sUserName, $sPassword)
	_POP3_IsAuthorized(False)

	_POP3_IsConnected()
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	__POP3_SendCommand("USER " & $sUserName, $POP3_ERR_USER_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	__POP3_SendCommand("PASS " & $sPassword, $POP3_ERR_PASS_REFUSED)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	_POP3_IsAuthorized(True)
	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $POP3_RET_SUCCESS)
EndFunc   ;==>_POP3_ServerLogIn

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_ServerResponseTimeOut
; Description ...: Set/Get $iServerResponseTimeOut
; Syntax ........: _POP3_ServerResponseTimeOut([$iTimeOut = Default])
; Parameters ....: $iTimeOut            - [optional] an integer value. Default is Default = Return current value.
; Return values .: $iServerResponseTimeOut
; Author ........: mLipok
; Modified ......:
; Remarks .......: Default setting is 60000 ms = 1 minute
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_ServerResponseTimeOut($iTimeOut = Default)
	Local Static $iServerResponseTimeOut = 60000
	If Not IsNumber($iTimeOut) Or Not StringIsDigit($iTimeOut) Then SetError(1, 0, $iServerResponseTimeOut)
	If $iTimeOut <> Default Then $iServerResponseTimeOut = $iTimeOut
	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $iServerResponseTimeOut)
EndFunc   ;==>_POP3_ServerResponseTimeOut

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_IsAuthorized
; Description ...: Set/Check whether user is loged to the POP3 server
; Syntax ........: _POP3_IsAuthorized([$bState = Default])
; Parameters ....: $bState              - [optional] A binary value. Default is Default = do not change nothing just return Current status.
; Return values .: Status, current or just set
; Author ........: mLipok
; Modified ......:
; Remarks .......: Default Status is False
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_IsAuthorized($bState = Default)
	Local Static $bIsAuth_static = False
	If IsBool($bState) Then $bIsAuth_static = $bState

	If $bState <> Default And Not IsBool($bState) Then
		Return SetError($POP3_ERR_PARAMETER, $POP3_EXT_PARAM1, $bIsAuth_static)
	ElseIf $bIsAuth_static Then
		Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $bIsAuth_static)
	EndIf

	Return SetError($POP3_ERR_NO_AUTH, $POP3_EXT_DEFAULT, $bIsAuth_static)
EndFunc   ;==>_POP3_IsAuthorized

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_IsConnected
; Description ...: Set/Check POP3 Connection Status
; Syntax ........: _POP3_IsConnected([$bState = Default])
; Parameters ....: $bState              - [optional] A binary value. Default is Default = do not change nothing just return Current status.
; Return values .: Status, current or just set
; Author ........: mLipok
; Modified ......:
; Remarks .......: Default Status is False
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_IsConnected($bState = Default)
	Local Static $bIsConnected_static = False
	If IsBool($bState) Then $bIsConnected_static = $bState

	If $bState <> Default And Not IsBool($bState) Then
		Return SetError($POP3_ERR_PARAMETER, $POP3_EXT_PARAM1, $bIsConnected_static)
	ElseIf $bIsConnected_static Then
		Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $bIsConnected_static)
	EndIf

	_POP3_IsAuthorized(False)
	_POP3_CallbackError("_POP3_IsConnected: $POP3_ERR_NOT_CONNECTED")
	Return SetError($POP3_ERR_NOT_CONNECTED, $POP3_EXT_DEFAULT, $bIsConnected_static)
EndFunc   ;==>_POP3_IsConnected

; #FUNCTION# ===================================================================
; Name ..........: _POP3_ServerDisconnect
; Description ...: Shuts down connection to POP3 server.
; Syntax ........: _POP3_ServerDisconnect()
; Parameter(s): .: none
; Return Value ..: Success - 1
; Failure - 0
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; Remark(s) .....: Use _POP3_RFC_QUIT to exit !!
; Link ..........:
; Related .......:
; Example .......: No
; ==============================================================================
Func _POP3_ServerDisconnect()
	If _POP3_IsConnected() Then
		TCPCloseSocket($__g_iPOP3_SOCKET)
		TCPShutdown()
	EndIf
	_POP3_IsConnected(False)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $POP3_RET_SUCCESS)
EndFunc   ;==>_POP3_ServerDisconnect

; #FUNCTION# ===================================================================
; Name ..........: _POP3_MsgCnt
; Description ...: Returns the number of messages
; Syntax ........: _POP3_MsgCnt()
; Parameter(s): .: none
; Return Value ..: Success - number of messages
; Failure - -1
; @ERROR -
; Author(s) .....: Thorsten Willert
; Link ..........:
; Related .......: _POP3_RFC_STAT
; Example .......: NO
; ==============================================================================
Func _POP3_MsgCnt()
	Local $a = _POP3_RFC_STAT() ; @TODO $a ??
	Return SetError(@error, @extended, $a[0])
EndFunc   ;==>_POP3_MsgCnt

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_UDFVersion
; Description ...: Get UDFVersion number
; Syntax ........: _POP3_UDFVersion()
; Parameters ....: none
; Return values .: UDF Version
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_UDFVersion()
	Return '2.0.1'
EndFunc   ;==>_POP3_UDFVersion
#EndRegion POP3.au3 - UDF Function

#Region POP3.au3 - _EML_ Functions

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_SaveToFile
; Description ...:
; Syntax ........: _POP3_EML_SaveToFile($iMessageNumber, $sEML_FileFullPath)
; Parameters ....: $iMessageNumber                - An integer value.
;                  $sEML_FileFullPath   - A string value. FileFullPath to save EML file.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_SaveToFile($iMessageNumber, $sEML_FileFullPath)
	Local $sEMLContent = _POP3_RFC_RETR($iMessageNumber)
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

;~ 	_POP3_Callback(StringStripCR($sEML) & @CR)
	Local $hEML_File = FileOpen($sEML_FileFullPath, $FO_OVERWRITE + $FO_CREATEPATH + $FO_UTF8_FULL)
	FileWrite($hEML_File, $sEMLContent)
	FileClose($hEML_File)
EndFunc   ;==>_POP3_EML_SaveToFile

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_GetDate
; Description ...:
; Syntax ........: _POP3_EML_GetDate($sEML_Content)
; Parameters ....: $sEML_Content        - A string value.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_GetDate($sEML_Content)
	Local $aDate = StringRegExp($sEML_Content, '(?i)(?:\A|\R)Date: (\V+)', $STR_REGEXPARRAYGLOBALMATCH)
	If UBound($aDate) Then
		Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aDate[0])
	EndIf
	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, '')
EndFunc   ;==>_POP3_EML_GetDate

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_GetSubject
; Description ...:
; Syntax ........: _POP3_EML_GetSubject($sEML_Content[, $bDecodeQP = True])
; Parameters ....: $sEML_Content        - A string value.
;                  $bDecodeQP           - [optional] A binary value. Default is True.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_GetSubject($sEML_Content, $bDecodeQP = True)
	Local $aSubject = StringRegExp($sEML_Content, '(?i)(?:\A|\R)Subject: (\V+)', $STR_REGEXPARRAYGLOBALMATCH)
	If UBound($aSubject) Then Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $bDecodeQP ? _QuotedPrintable_DecodeEncodedWord($aSubject[0]) : $aSubject[0])

	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, '')
EndFunc   ;==>_POP3_EML_GetSubject

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_GetThreadTopic
; Description ...:
; Syntax ........: _POP3_EML_GetThreadTopic($sEML_Content[, $bDecodeQP = True])
; Parameters ....: $sEML_Content        - A string value.
;                  $bDecodeQP           - [optional] A binary value. Default is True.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_GetThreadTopic($sEML_Content, $bDecodeQP = True)
	Local $aTopic = StringRegExp($sEML_Content, '(?i)(?:\A|\R)Thread-Topic: (\V+)', $STR_REGEXPARRAYGLOBALMATCH)
	If UBound($aTopic) Then Return SetError(0, 0, $bDecodeQP ? _QuotedPrintable_DecodeEncodedWord($aTopic[0]) : $aTopic[0])

	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, '')
EndFunc   ;==>_POP3_EML_GetThreadTopic

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_GetFrom
; Description ...:
; Syntax ........: _POP3_EML_GetFrom($sEML_Content[, $bDecodeQP = True])
; Parameters ....: $sEML_Content        - A string value.
;                  $bDecodeQP           - [optional] A binary value. Default is True.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_GetFrom($sEML_Content, $bDecodeQP = True)
	Local $aFrom = StringRegExp($sEML_Content, '(?i)(?:\A|\R)From: (\V+)', $STR_REGEXPARRAYGLOBALMATCH)
	If UBound($aFrom) Then Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $bDecodeQP ? _QuotedPrintable_DecodeEncodedWord($aFrom[0]) : $aFrom[0])
	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, '')
EndFunc   ;==>_POP3_EML_GetFrom

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_GetTo
; Description ...:
; Syntax ........: _POP3_EML_GetTo($sEML_Content[, $bDecodeQP = True])
; Parameters ....: $sEML_Content        - A string value.
;                  $bDecodeQP           - [optional] A binary value. Default is True.
; Return values .: None
; Author ........: mLipok
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_GetTo($sEML_Content, $bDecodeQP = True)
	Local $aTo = StringRegExp($sEML_Content, '(?i)(?:\A|\R)To: (\V+)', $STR_REGEXPARRAYGLOBALMATCH)
	If UBound($aTo) Then
		Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $bDecodeQP ? _QuotedPrintable_DecodeEncodedWord($aTo[0]) : $aTo[0])
	EndIf
	Return SetError($POP3_ERR_GENERAL, $POP3_EXT_DEFAULT, '')
EndFunc   ;==>_POP3_EML_GetTo

; #FUNCTION# ====================================================================================================================
; Name ..........: _POP3_EML_Parser
; Description ...:
; Syntax ........: _POP3_EML_Parser ($sEML_Contents)
; Parameters ....: $sEML_Contents           - A string value.
; Return values .:
;                 It returns an Array where saved:
;                 In the 1st line - Sender's name
;                 In the 2nd line - Sender's address
;                 In the 3rd line - Recipient name
;                 In the 4th line - Recipient address
;                 In the 5th line - Subject
;                 In the 6th line - Charset
;                 In the 7th line - Message body
;                 In the 8th line - Attachment's name (if exists)
;                 In the 9th line - Attachment's body (if exists)
;                 In the next pairs of lines - names and bodies of the other attachments (if exist)
; Author ........: Tipulatoid, MrCreatoR
; Modified ......: mLipok
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/22838-POP3-udf-according-to-the-1939-rfc/#entry596715
; Example .......: No
; ===============================================================================================================================
Func _POP3_EML_Parser($sEML_Contents)
	Local $aLetter[1]
	__POP3_EML_Parser_AddToLetterArray(StringRegExp($sEML_Contents, '(?im)^From: +(.*)(?: |<)(?:.*?<|)(.*?)(?:>|)\r\n', $STR_REGEXPARRAYMATCH), $aLetter)
	__POP3_EML_Parser_AddToLetterArray(StringRegExp($sEML_Contents, '(?im)^To: +(.*)(?: |<)(?:.*?<|)(.*?)(?:>|)\r\n', $STR_REGEXPARRAYMATCH), $aLetter)
	__POP3_EML_Parser_AddToLetterArray(StringRegExp($sEML_Contents, '(?im)^Subject: +(.*)\r\n', $STR_REGEXPARRAYMATCH), $aLetter)
	__POP3_EML_Parser_AddToLetterArray(StringRegExp($sEML_Contents, '(?i)charset="?(.*?)(?:"|\r\n)', $STR_REGEXPARRAYMATCH), $aLetter)

	Local $aSplit = StringSplit($sEML_Contents, @CRLF, $STR_ENTIRESPLIT)
	Local $iFirstBoundaryString = _ArraySearch($aSplit, "boundary=", 0, 0, 0, 1)
	Local $iBoundary = $aSplit[$iFirstBoundaryString]
	Local $iBoundary_StartPos = StringInStr($iBoundary, '"')
	Local $iBoundary_EndPos = StringInStr($iBoundary, '"', 0, 2)
	Local $boundary = StringMid($iBoundary, $iBoundary_StartPos + 1, $iBoundary_EndPos - $iBoundary_StartPos - 1)
	Local $boundary1 = _ArraySearch($aSplit, $boundary, $iFirstBoundaryString + 1, 0, 1, 1)
	Local $boundary2 = _ArraySearch($aSplit, $boundary, $boundary1 + 1, 0, 1, 1)
	Local $sMessage = ""
	Local $bWrite = False ; TODO Refactoring $bWrite
	For $i = $boundary1 To $boundary2 - 1
		If $aSplit[$i] = "" Then $bWrite = True
		If $bWrite Then $sMessage &= $aSplit[$i] & @CRLF
	Next
	__POP3_EML_Parser_AddToLetterArray($sMessage, $aLetter)

	__POP3_EML_Parser_AddToLetterArray(StringRegExp($sEML_Contents, '(?ims)\tfilename="?(.*?)(?:"\R\R)(.*?)(?:------\=_NextPart)', $STR_REGEXPARRAYGLOBALMATCH), $aLetter)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $aLetter)
EndFunc   ;==>_POP3_EML_Parser

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __POP3_EML_Parser_AddToLetterArray
; Description ...:
; Syntax ........: __POP3_EML_Parser_AddToLetterArray($aContents, Byref $afLetter)
; Parameters ....: $aContents           - An array of unknowns.
;                  $afLetter            - [in/out] An array of booleans.
; Return values .: None
; Author ........: Tipulatoid, MrCreatoR
; Modified ......:
; Remarks .......:
; Related .......:
; Link ..........: http://www.autoitscript.com/forum/topic/22838-POP3-udf-according-to-the-1939-rfc/#entry596715
; Example .......: No
; ===============================================================================================================================
Func __POP3_EML_Parser_AddToLetterArray($aContents, ByRef $afLetter)
	If IsArray($aContents) Then
		For $i_ID = 0 To UBound($aContents) - 1
			_ArrayAdd($afLetter, $aContents[$i_ID])
		Next
	Else
		_ArrayAdd($afLetter, $aContents)
	EndIf
	; Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $afLetter)
EndFunc   ;==>__POP3_EML_Parser_AddToLetterArray

#EndRegion POP3.au3 - _EML_ Functions

#Region POP3.au3 - Callback Functions
Func _POP3_CallbackError($vData, $iError = @error, $iExtended = @extended)
	Local Static $sFunction_Static = Default
	If IsFunc($vData) Then
		$sFunction_Static = $vData
	ElseIf $sFunction_Static <> Default Then
		$sFunction_Static("[ " & $iError & " / " & $iExtended & " ]   " & $vData & @CRLF)
	EndIf
	Return SetError($iError, $iExtended, $vData)
EndFunc   ;==>_POP3_CallbackError

Func _POP3_Callback($vData, $iError = @error, $iExtended = @extended)
	Local Static $sFunction_Static = Default
	If IsFunc($vData) Then
		$sFunction_Static = $vData
	ElseIf $sFunction_Static <> Default Then
;~ 		$sFunction_Static($vData & @CRLF)
		$vData = StringRegExpReplace($vData, $POP3_REGEXP_PASS, $POP3_CALLBACK_COMMAND & "PASS XXXXXXXX")
		$sFunction_Static($vData)
	EndIf
	Return SetError($iError, $iExtended, $vData)
EndFunc   ;==>_POP3_Callback

#EndRegion POP3.au3 - Callback Functions

#Region POP3.au3 - #INTERNAL_USE_ONLY#
; #INTERNAL_USE_ONLY# ==========================================================
; Name ..........: __POP3_SendCommand
; Description ...:
; Syntax ........: __POP3_SendCommand($sCommand)
; Parameter(s): .: $sCommand -
; Return Value ..: Success - string
; Failure - 0
; @ERROR -
; Author(s) .....: Thorsten Willert
; ==============================================================================
Func __POP3_SendCommand($sCommand, $iERROR_MSG)
	_POP3_Callback($POP3_CALLBACK_COMMAND & $sCommand & @CRLF)
	TCPSend($__g_iPOP3_SOCKET, $sCommand & @CRLF)
	If @error Then
		_POP3_CallbackError("__POP3_SendCommand: $iERROR_MSG=" & $iERROR_MSG)
		Return SetError($iERROR_MSG, @error, $POP3_RET_FAILURE)
	EndIf

	Local $sResult = __POP3_WaitForOK()
	If @error Then Return SetError(@error, @extended, $POP3_RET_FAILURE)

	Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
EndFunc   ;==>__POP3_SendCommand

; #INTERNAL_USE_ONLY# ==========================================================
; Name ..........: __POP3_WaitForOK
; Description ...: Returns the server response if it starts with "+OK"
; Syntax ........: __POP3_WaitForOK()
; Parameter(s): .: none
; Return Value ..: Success - string
; Failure - ""
; @ERROR -
; Author(s) .....: Luc HENNINOT, Thorsten Willert
; ==============================================================================
Func __POP3_WaitForOK()
	Local $sResult = ''
	Local $hTimer = TimerInit()
	While TimerDiff($hTimer) < _POP3_ServerResponseTimeOut()
		$sResult = __POP3_WaitTcpResponse()
		If @error Then
			Return SetError(@error, @extended, $POP3_RET_FAILURE)
		ElseIf StringRegExp($sResult, $POP3_REGEXP_ERR) Then
			_POP3_CallbackError("__POP3_WaitForOK: $POP3_ERR_ERR_RESPONSE")
			Return SetError($POP3_ERR_ERR_RESPONSE, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
		ElseIf StringRegExp($sResult, $POP3_REGEXP_OK) Then
			Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, StringRegExpReplace($sResult, $POP3_REGEXP_OK, ""))
		EndIf

		Sleep(100)
	WEnd

	_POP3_CallbackError("__POP3_WaitForOK: $POP3_ERR_TIMEOUT")
	Return SetError($POP3_ERR_TIMEOUT, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
EndFunc   ;==>__POP3_WaitForOK

; #INTERNAL_USE_ONLY# ===========================================================================================================
; Name ..........: __POP3_WaitTcpResponse
; Description ...: Returns the server response
; Syntax ........: __POP3_WaitTcpResponse([$bRunCallback = True])
; Parameters ....: $bRunCallback        - [optional] a boolean value. Default is True.
; Return values .:
;                 Success - string
;                 Failure - 0
; Author ........: Luc HENNINOT
; Modified ......: Thorsten Willert, mLipok
; Remarks .......: Default Timeout is 60 s. Change it if needed by using _POP3_ServerResponseTimeOut()
; Related .......: _POP3_ServerResponseTimeOut()
; Link ..........:
; Example .......: No
; ===============================================================================================================================
Func __POP3_WaitTcpResponse($bRunCallback = True)
	Local $sResult = ""
	Local $hTimer = TimerInit()

	While TimerDiff($hTimer) < _POP3_ServerResponseTimeOut()
		$sResult = TCPRecv($__g_iPOP3_SOCKET, 512, $TCP_DATA_DEFAULT)
		If @error Then
			_POP3_CallbackError('__POP3_WaitTcpResponse(): $POP3_ERR_TCPRECV')
			Return SetError($POP3_ERR_TCPRECV, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
		ElseIf $sResult <> "" Then
			If $bRunCallback Then _POP3_Callback($POP3_CALLBACK_STATUS & $sResult)
			Return SetError($POP3_ERR_SUCCESS, $POP3_EXT_DEFAULT, $sResult)
		EndIf
		Sleep(100)
	WEnd

	_POP3_CallbackError('__POP3_WaitTcpResponse(): $POP3_ERR_TIMEOUT')
	Return SetError($POP3_ERR_TIMEOUT, $POP3_EXT_DEFAULT, $POP3_RET_FAILURE)
EndFunc   ;==>__POP3_WaitTcpResponse

#EndRegion POP3.au3 - #INTERNAL_USE_ONLY#

#CS
	7. Optional POP3 Commands
	http://www.freesoft.org/CIE/RFC/1725/7.htm

	Standard for the Format of ARPA-Internet Text Messages ( https://tools.ietf.org/html/rfc822 )
	; 4.  MESSAGE SPECIFICATION
	;	4.1.  SYNTAX
	; 5.  DATE AND TIME SPECIFICATION
	;	5.1.  SYNTAX

	POP3 AUTHentication command ( https://www.ietf.org/rfc/rfc1734.txt )

	MIME
	https://tools.ietf.org/html/rfc1341
	http://pl.wikipedia.org/wiki/Multipurpose_Internet_Mail_Extensions
#CE
