﻿#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6 -w 7

#include <array.au3>
#include <FileConstants.au3>
#include "POP3.au3"
#include "Quoted-printable.au3"

ConsoleWrite('POP3.au3 UDF v.' & _POP3_UDFVersion() & @CRLF)
ConsoleWrite('@AutoItVersion=' & @AutoItVersion & @CRLF)

Global $sPOP3_MyPopServer = "xxxx"
Global $sPOP3_MyLogin = "xxxx"
Global $sPOP3_MyPasswd = "xxxx"

;~ _POP3_ServerResponseTimeOut(60000)
_POP3_Callback(_MyPOP3_Callback)
_POP3_CallbackError(_MyPOP3_CallbackError)

_Example_1()
If @error Then MsgBox($MB_ICONERROR, '_Example_1', '@error = ' & @error & @CRLF & '@extended = ' & @extended)

_Example_2_UIDL()
If @error Then MsgBox($MB_ICONERROR, '_Example_1', '@error = ' & @error & @CRLF & '@extended = ' & @extended)

Func _Example_1()
	_POP3_ServerConnect($sPOP3_MyPopServer)
	If @error Then Return SetError(@error, @extended, '')

	_POP3_ServerLogIn($sPOP3_MyLogin, $sPOP3_MyPasswd)
	If @error Then Return SetError(@error, @extended, '')

	_POP3_RFC_LIST(1)
	If @error Then Return SetError(@error, @extended, '')

	_POP3_EML_SaveToFile(1, @ScriptDir & '\Test_' & @YEAR & @MON & @MDAY & '_' & @HOUR & @MIN & @SEC & '.eml')
	If @error Then Return SetError(@error, @extended, '')

;~ 	_POP3_RFC_DELE(1)
;~ 	If @error Then Return SetError(@error, @extended, '')

	_POP3_RFC_QUIT()
	If @error Then Return SetError(@error, @extended, '')

	_POP3_ServerDisconnect()
EndFunc   ;==>_Example_1

Func _Example_2_UIDL()
	_POP3_ServerConnect($sPOP3_MyPopServer)
	If @error Then Return SetError(@error, @extended, '')

	_POP3_ServerLogIn($sPOP3_MyLogin, $sPOP3_MyPasswd)
	If Not @error Then
		Local $aUIDL = _POP3_RFC_UIDL()
		If Not @error Then _ArrayDisplay($aUIDL, '_POP3_RFC_UIDL() Results')

		_POP3_RFC_QUIT()
	EndIf

	_POP3_ServerDisconnect()
EndFunc   ;==>_Example_2_UIDL

Func _MyPOP3_Callback($sText)
	ConsoleWrite($sText)
EndFunc   ;==>_MyPOP3_Callback

Func _MyPOP3_CallbackError($sText)
	ConsoleWrite('! ' & $sText)
EndFunc   ;==>_MyPOP3_CallbackError
